import java.util.LinkedList;
import java.util.Random;
import java.util.stream.Stream;

/**
 * 
 * @author Lorenz Schauer
 * 
 * Programm zum Umgang mit Streams und Lambda-Expressions aus dem Javakurs fr Fortgeschrittene vom 27.07.2017 - Aufgabe 1
 * 
 * Der Code stellt nur eine mgliche Lsung dar. Es gibt wie immer verschiedene Wege zum Ziel ;) 
 *
 */

public class Programm {
	
	private LinkedList<Integer> myList;
	
	public Programm(){
	
		// Liste initialisieren
		this.myList = new LinkedList<Integer>();
		this.addNumbersToList();
	}
	
	private void addNumbersToList(){
		
		Random r = new Random();
		
		// Zufallszahlen generieren und in die Liste einfuegen.
		for(int i=0;i<100;i++){
			this.myList.add(r.nextInt(1000));
		}
	}
	
	public LinkedList<Integer> getMyList(){
		return this.myList;
	}
	
	
	
	public static void main(String[] args) {
		
		
		Programm p = new Programm();
		
		// Liste Holen
		LinkedList<Integer> myList = p.getMyList();

		// Alle Zahlen ausgeben:
		//myList.forEach(System.out::println);
		

		Stream<Integer> myStream = myList.stream();
		
		//################################
		// Zum Prfen der jeweiligen Anfrage, einfach die entsprechende Code-Zeile auskommentieren.
		//################################
		
		
		// Zahlen geordnet ausgeben
		// myStream.sorted().forEach(System.out::println);
		// myStream.sorted(Collections.reverseOrder()).forEach(System.out::println);
		
		// Alle ungeraden Zahlen ausgeben:
//		myStream.filter(x -> !(x%2==0))
//		.forEach(System.out::println);
		
		// 
		
		// Anzahl der Zahlen, die durch 4 teilbar sind:	
		//System.out.println(myStream.filter(x->x%4==0).count());
		
		// Kleinste Zahl:
		//System.out.println(myStream.min(Comparator.naturalOrder()).get());

		// Grte Zahl:
		//System.out.println(myStream.max(Comparator.naturalOrder()).get());
		
		// Quadratsumme:
		//int qudrat_summe = myStream.map(x->x*x).reduce(Integer::sum).get();
		//System.out.println(qudrat_summe);
		
		// Durchschnitt: 
		//double durchschnitt = myStream.mapToInt(Integer::valueOf).average().getAsDouble();
		//System.out.println(durchschnitt);
		
		// +5 > 100
		myStream.map(x->x+5)
			.filter(x->x>100)
			.forEach(System.out::println);
		
		
		
	}

}
